%define anolis_release 1

%global _hardened_build 1

Summary: The client program for the Telnet remote login protocol
Name: telnet
Version: 0.17
Release: %{anolis_release}%{?dist}
Epoch: 1
License: BSD
Url: http://web.archive.org/web/20070819111735/www.hcs.harvard.edu/~dholland/computers/old-netkit.html
Source0: http://ftp.linux.org.uk/pub/linux/Networking/netkit/netkit-telnet-%{version}.tar.gz
# telnet-client tarball is snapshot of the OpenBSD client telnet
Source1: telnet-client.tar.gz
Source2: telnet@.service
Source3: telnet.socket

Patch1: telnet-client-cvs.patch
Patch2: telnetd-0.17.diff
Patch3: telnet-0.17-env.patch
Patch4: telnet-0.17-issue.patch
Patch5: telnet-0.17-sa-01-49.patch
Patch6: telnet-0.17-pek.patch
Patch7: telnet-0.17-8bit.patch
Patch8: telnet-0.17-argv.patch
Patch9: telnet-0.17-conf.patch
Patch10: telnet-0.17-cleanup_race.patch
Patch11: telnetd-0.17-pty_read.patch
Patch12: telnet-0.17-CAN-2005-468_469.patch
Patch13: telnet-gethostbyname.patch
Patch14: netkit-telnet-0.17-ipv6.diff
Patch15: netkit-telnet-0.17-nodns.patch
Patch16: telnet-0.17-errno_test_sys_bsd.patch
Patch17: netkit-telnet-0.17-reallynodns.patch
Patch18: telnet-rh678324.patch
Patch19: telnet-rh674942.patch
Patch20: telnet-rh704604.patch
Patch21: telnet-rh825946.patch
Patch22: telnet-0.17-force-ipv6-ipv4.patch
Patch23: netkit-telnet-0.17-core-dump.patch
Patch24: netkit-telnet-0.17-gcc7.patch
Patch25: netkit-telnet-0.17-manpage.patch
Patch26: netkit-telnet-0.17-telnetrc.patch
Patch27: telnet-log-address.patch
Patch28: telnet-0.17-overflow-exploit.patch
Patch29: telnet-0.17-pty-retry.patch

BuildRequires: make
BuildRequires: ncurses-devel systemd gcc gcc-c++
BuildRequires: perl-interpreter

%description
Telnet is a popular protocol for logging into remote systems over the
Internet. The package provides a command line Telnet client

%package server
Requires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Summary: The server program for the Telnet remote login protocol

%description server
Telnet is a popular protocol for logging into remote systems over the
Internet. The package includes a daemon that supports Telnet remote
logins into the host machine. The daemon is disabled by default.
You may enable the daemon by editing /etc/xinetd.d/telnet

%package doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description doc
Doc files for %{name}

%prep
%setup -q -n netkit-telnet-%{version}

mv telnet telnet-NETKIT
%setup -T -D -q -a 1 -n netkit-telnet-%{version}

%autopatch -p1

%build
export CC_FLAGS="$RPM_OPT_FLAGS -fpie"
export LD_FLAGS="$RPM_LD_FLAGS -z now -pie"

sh configure --with-c-compiler=%{__cc} 
perl -pi -e '
    s,-O2,\$(CC_FLAGS),;
    s,LDFLAGS=.*,LDFLAGS=\$(LD_FLAGS),;
    s,^BINDIR=.*$,BINDIR=%{_bindir},;
    s,^MANDIR=.*$,MANDIR=%{_mandir},;
    s,^SBINDIR=.*$,SBINDIR=%{_sbindir},;
    ' MCONFIG

# remove stripping
perl -pi -e 's|install[ ]+-s|install|g' \
    ./telnet/GNUmakefile \
    ./telnetd/Makefile \
    ./telnetlogin/Makefile \
    ./telnet-NETKIT/Makefile

%{make_build}

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man5
mkdir -p %{buildroot}%{_mandir}/man8

make INSTALLROOT=%{buildroot} install

install -D -p -m644 %SOURCE2 %{buildroot}%{_unitdir}/telnet@.service
install -D -p -m644 %SOURCE3 %{buildroot}%{_unitdir}/telnet.socket

%post server
%systemd_post telnet.socket

%preun server
%systemd_preun telnet.socket

%postun server
%systemd_postun_with_restart telnet.socket

%files
%{_bindir}/telnet
%{_mandir}/man1/telnet.1*

%files server
%{_unitdir}/*
%{_sbindir}/in.telnetd
%{_mandir}/man5/issue.net.5*
%{_mandir}/man8/in.telnetd.8*
%{_mandir}/man8/telnetd.8*

%files doc
%doc README

%changelog
* Thu Mar 16 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:0.17-1
- init from upstream
